// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from splsm_7:msg/SPLSM.idl
// generated code does not contain a copyright notice
#include "splsm_7/msg/detail/splsm__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `data`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
splsm_7__msg__SPLSM__init(splsm_7__msg__SPLSM * msg)
{
  if (!msg) {
    return false;
  }
  // player_num
  msg->player_num = 0;
  // team_num
  msg->team_num = 0;
  // fallen
  msg->fallen = 255;
  // pose
  msg->pose[0] = 0.0f;
  msg->pose[1] = 0.0f;
  msg->pose[2] = 0.0f;
  // ball_age
  msg->ball_age = -1.0f;
  // ball
  msg->ball[0] = 0.0f;
  msg->ball[1] = 0.0f;
  // data
  if (!rosidl_runtime_c__uint8__Sequence__init(&msg->data, 0)) {
    splsm_7__msg__SPLSM__fini(msg);
    return false;
  }
  return true;
}

void
splsm_7__msg__SPLSM__fini(splsm_7__msg__SPLSM * msg)
{
  if (!msg) {
    return;
  }
  // player_num
  // team_num
  // fallen
  // pose
  // ball_age
  // ball
  // data
  rosidl_runtime_c__uint8__Sequence__fini(&msg->data);
}

bool
splsm_7__msg__SPLSM__are_equal(const splsm_7__msg__SPLSM * lhs, const splsm_7__msg__SPLSM * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // player_num
  if (lhs->player_num != rhs->player_num) {
    return false;
  }
  // team_num
  if (lhs->team_num != rhs->team_num) {
    return false;
  }
  // fallen
  if (lhs->fallen != rhs->fallen) {
    return false;
  }
  // pose
  for (size_t i = 0; i < 3; ++i) {
    if (lhs->pose[i] != rhs->pose[i]) {
      return false;
    }
  }
  // ball_age
  if (lhs->ball_age != rhs->ball_age) {
    return false;
  }
  // ball
  for (size_t i = 0; i < 2; ++i) {
    if (lhs->ball[i] != rhs->ball[i]) {
      return false;
    }
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__are_equal(
      &(lhs->data), &(rhs->data)))
  {
    return false;
  }
  return true;
}

bool
splsm_7__msg__SPLSM__copy(
  const splsm_7__msg__SPLSM * input,
  splsm_7__msg__SPLSM * output)
{
  if (!input || !output) {
    return false;
  }
  // player_num
  output->player_num = input->player_num;
  // team_num
  output->team_num = input->team_num;
  // fallen
  output->fallen = input->fallen;
  // pose
  for (size_t i = 0; i < 3; ++i) {
    output->pose[i] = input->pose[i];
  }
  // ball_age
  output->ball_age = input->ball_age;
  // ball
  for (size_t i = 0; i < 2; ++i) {
    output->ball[i] = input->ball[i];
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__copy(
      &(input->data), &(output->data)))
  {
    return false;
  }
  return true;
}

splsm_7__msg__SPLSM *
splsm_7__msg__SPLSM__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  splsm_7__msg__SPLSM * msg = (splsm_7__msg__SPLSM *)allocator.allocate(sizeof(splsm_7__msg__SPLSM), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(splsm_7__msg__SPLSM));
  bool success = splsm_7__msg__SPLSM__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
splsm_7__msg__SPLSM__destroy(splsm_7__msg__SPLSM * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    splsm_7__msg__SPLSM__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
splsm_7__msg__SPLSM__Sequence__init(splsm_7__msg__SPLSM__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  splsm_7__msg__SPLSM * data = NULL;

  if (size) {
    data = (splsm_7__msg__SPLSM *)allocator.zero_allocate(size, sizeof(splsm_7__msg__SPLSM), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = splsm_7__msg__SPLSM__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        splsm_7__msg__SPLSM__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
splsm_7__msg__SPLSM__Sequence__fini(splsm_7__msg__SPLSM__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      splsm_7__msg__SPLSM__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

splsm_7__msg__SPLSM__Sequence *
splsm_7__msg__SPLSM__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  splsm_7__msg__SPLSM__Sequence * array = (splsm_7__msg__SPLSM__Sequence *)allocator.allocate(sizeof(splsm_7__msg__SPLSM__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = splsm_7__msg__SPLSM__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
splsm_7__msg__SPLSM__Sequence__destroy(splsm_7__msg__SPLSM__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    splsm_7__msg__SPLSM__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
splsm_7__msg__SPLSM__Sequence__are_equal(const splsm_7__msg__SPLSM__Sequence * lhs, const splsm_7__msg__SPLSM__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!splsm_7__msg__SPLSM__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
splsm_7__msg__SPLSM__Sequence__copy(
  const splsm_7__msg__SPLSM__Sequence * input,
  splsm_7__msg__SPLSM__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(splsm_7__msg__SPLSM);
    splsm_7__msg__SPLSM * data =
      (splsm_7__msg__SPLSM *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!splsm_7__msg__SPLSM__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          splsm_7__msg__SPLSM__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!splsm_7__msg__SPLSM__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
